import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import de.bezier.data.*; 
import java.awt.geom.*; 
import java.awt.geom.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class finalProj_johara3 extends PApplet {

/* 
Johara Mansura
Data Visualisation, June 2014
Wits Digital Art
Visual Map of Top 5 Complaints Received From different Income Groups

Project to view perceptions of different income groups in terms of the top 5 problems cited in the survey

Scrollbar taken from Processing Examples site: http://www.processing.org/examples/scrollbar.html
*/


PFont font1, font2, font3;
HScrollbar hs1;
Circle circle, bigCircle;

PImage img1;
PImage img2;
XlsReader reader;

int fillColor = color(255,200);
int fillColor2 = color(100,200,100,200);

String[] income = new String[19];
int[] income2 = new int[19];
String[] probName = new String[7];
String[] nameArray = new String[7];
int[] crime = new int [19];
int[] basicServ = new int [19];
int[] unemployment = new int [19];
int[] maintenance = new int [19];
int[] last = new int [19];
int[] drugs = new int [19];
int[] positX= new int [6];
int[] positY= new int [6];



int[][] arrays = new int[][] { crime, basicServ, unemployment, maintenance, drugs,last};

public void setup()
{
  size(900,734);
  img1 = loadImage("gau3.jpg");
  img2 = loadImage("pointer.png");
 
  font1 = loadFont("ArialNarrow-Bold-20.vlw"); 
  font2 = loadFont("Corbel-48.vlw"); 
  font3 = loadFont("Corbel-48.vlw");  
  hs1 = new HScrollbar(0, 620, width, 16,8);
  reader = new XlsReader( this, "goc.xls" );
  circle = new Circle(50,50,fillColor);
  bigCircle = new Circle(50,50,fillColor2);
  smooth();
}

public void draw() 
{
  background(img1);
  
  
  //getting values for slider
   int counter = 1;
  int lineSp = 50;
  String name;
  
  for (int u = 1; u<6; u++)
  {
    positX[u] = reader.getInt(20,u);
    positY[u] = reader.getInt(21,u);
    probName[u] = reader.getString(0,u);
    name = nameArray[u];
    for (int j =1; j<19; j++)
    {
      //text from Xls Reader, income of household
     income[j] = reader.getString(j,0);
     //numerical values for this
     income2[j] = reader.getInt(j,6);
     //all values for problems
     arrays[u][j] = reader.getInt(j,u);
    //c1.drawCircle(arrays[u][j],positX,positY);
    
    textSize(9);
    textFont(font1,11);
    textAlign(RIGHT, BOTTOM);
    text(income[j], lineSp+4,710);
    //text(income[counter+1], lineSp+50,720);
    lineSp = lineSp+50;
    }
  }
 

   
  
  int space = 0;
  
//lines leading from slider to values
  
  int lineSpace = 50;
  for (int i =0; i < 21; i++)
  {
    
  
    //slider value control area
    noStroke();
    fill(200-space/4,200-space/4,200,200);
    rect(space,620,55,30);
    stroke(200);
    strokeWeight(2);
    line(lineSpace+2,650,lineSpace+2,680);
    line(lineSpace+52,650,lineSpace+52,680);
    lineSpace = lineSpace+100;
   
    space = space+50;
    counter = counter +2;
    
  
  }
    
  
  
  
  fill(0,100);
  //rect(0,460,width,70);
  float img2Pos = hs1.getPos()-width/2;
  fill(255);
    
  hs1.update();
  hs1.display();
  
  stroke(0);
  //line(0, height/2, width, height/2);
  //image(img2, width/2-img2.width/2 + img2Pos*1.5,431);
  
 float position = hs1.getPos();
 updateVariables(position);
 
 noStroke();
 fill(0,180);
 rect(0,510,width,50);
 fill(200,180,130);
 textFont(font3,25);
 textAlign(CENTER, CENTER);
 text("Visual Map of Top 5 Complaints Received From different Income Groups",450,535);
 textFont(font3,21);
 fill(10,10,75);
 text("(Please move slider to view)",450,570);
 fill(255);

  
}


 public void updateVariables(float np)
  { 
  int spaceMin =0;
  int spaceMax = 50;
  for(int b=1; b<19; b++)
  {
    if (np > spaceMin && np < spaceMax)
    {
      for (int h = 1; h <6; h++)
        {
         circle.drawCircle(arrays[h][b],positX[h],positY[h]);
         //bigCircle.drawCircleAgain(income2[b],450,350);       
          fill(180,180,230);
         textFont(font2,22);
         textAlign(CENTER, CENTER);
         //text("Income of Household",450,350);
         //text(income2[b],450,380);
         fill(0);
         text(probName[h],positX[h],positY[h]);
         textFont(font2,20);
         textAlign(CENTER, BOTTOM);
         text(arrays[h][b]+" %",positX[h],positY[h]+35);
        }
        
    }
    spaceMin = spaceMin + 50;
    spaceMax = spaceMax + 50;
    }
  }
  


public class Circle {

  //
  int width;
  int height;
  boolean hasStroke = false;
  int strokeColor;
  boolean hasFill = false;
  int fillColor;
  int opacity;

  
  //
  Circle(int W, int H, int FILL) {
    width = W;
    height = H;
   
    fillColor = FILL;
    //
 
  }
  
 

   

  public void drawCircle(float value, int posX, int posY)
  {
    float v = value*7;
    float m = map(v,0,1575.5f,0,1575.5f);
    noStroke();
    fill(fillColor);
    ellipse(posX,posY,m,m); 
  } 
    
    
      public void drawCircleAgain(float value, int posX, int posY)
  {
    float v = value/1600;
    float m = map(v,0,1575.5f,0,1575.5f);
    noStroke();
    fill(fillColor);
    ellipse(posX,posY,m,m); 
  } 
  
 }   
    
       

    
    
    
    
    
    
    
    
    
    
    
    
    
  


//This is the coding taken from http://www.processing.org/examples/scrollbar.html



public class HScrollbar {
  
  
 
  int swidth, sheight;    // width and height of bar
  float xpos, ypos;       // x and y position of bar
  float spos, newspos;    // x position of slider
  float sposMin, sposMax; // max and min values of slider
  int loose;              // how loose/heavy
  boolean over;           // is the mouse over the slider?
  boolean locked;
  float ratio;
  PImage img2;
     

  HScrollbar (float xp, float yp, int sw, int sh, int l) {
    
    int ox;
    int oy;
    swidth = sw;
    sheight = sh;
    int widthtoheight = sw - sh;
    ratio = (float)sw / (float)widthtoheight;
    xpos = xp;
    ypos = yp-sheight/2;
    spos = xpos + swidth/2 - sheight/2;
    newspos = spos;
    sposMin = xpos;
    sposMax = xpos + swidth - sheight;
    loose = l;
    img2 = loadImage("pointer.png");
    
  }

  public void update() {
    if (overEvent()) {
      over = true;
    } else {
      over = false;
    }
    if (mousePressed && over) {
      locked = true;
    }
    if (!mousePressed) {
      locked = false;
    }
    if (locked) {
      newspos = constrain(mouseX-sheight/2, sposMin, sposMax);
      
    }
    if (abs(newspos - spos) > 1) {
      spos = spos + (newspos-spos)/loose;
    }
  }

  public float constrain(float val, float minv, float maxv) {
    return min(max(val, minv), maxv);
  }

  public boolean overEvent() {
    if (mouseX > xpos && mouseX < xpos+swidth &&
       mouseY > ypos-30 && mouseY < ypos+sheight) {
      return true;
    } else {
      return false;
    }
  }

  public void display() {
    noStroke();
    fill(200,180,130);
    rect(xpos, ypos, swidth, sheight);
   
    if (over || locked) {
      fill(255);
    } else {
      fill(102, 102, 102);
    }
    rect(spos, ypos, sheight, sheight);
     image(img2,spos-40,ypos-40);
  }

  public float getPos() {
    // Convert spos to be values between
    // 0 and the total width of the scrollbar
    return spos * ratio;
  }
 
  
          
 
}
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "--full-screen", "--bgcolor=#666666", "--stop-color=#cccccc", "finalProj_johara3" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
